// Int32Message.h
/*************************************************************************
* Copyright (c) 2002 The University of Chicago, as Operator of Argonne
* National Laboratory, and the Regents of the University of California, as
* Operator of Los Alamos National Laboratory. MPF is distributed
* subject to a Software License Agreement found in file LICENSE that
* is included with this distribution.
*************************************************************************/

#ifndef Int32MessageH
#define Int32MessageH

#include "Message.h"
#include "StandardFieldsMessage.h"
class DLList;

class Int32Message : public StandardFieldsMessage
{
public:
    Int32Message();
    virtual ~Int32Message() {}
    virtual int32  toBuffer(char **buffer) const;
    virtual int32  fromBuffer(const char **buffer);
    virtual int32  fromBufferSwitch(const char **buffer);
    virtual void print() const;
    static void *operator new(size_t size);
    void operator delete(void *p, size_t size);
    //following are for use by client/server
    int32 value;
protected:
    Int32Message(messageType type);
private:
    static DLList *pFreeList;
    // Disallow copy constructor, assignment operator 
    Int32Message(const Int32Message&);
    Int32Message& operator=(const Int32Message&);
};

#endif /*Int32MessageH*/
