// xxxMessage.cc
/*************************************************************************
* Copyright (c) 2002 The University of Chicago, as Operator of Argonne
* National Laboratory, and the Regents of the University of California, as
* Operator of Los Alamos National Laboratory. MPF is distributed
* subject to a Software License Agreement found in file LICENSE that
* is included with this distribution.
*************************************************************************/

#include <stdlib.h>
#include <stddef.h>
#include <string.h>
#include <stdio.h>
#include <epicsThread.h>

#include "Message.h"
#include "xxxMessage.h"

DLList* xxxMessage::pFreeList = 0;

xxxMessage:: xxxMessage()
: Message(messageTypexxx) // initialize member date
{}

xxxMessage:: xxxMessage(messageType type)
: Message(type) // initialize member date
{}

int32 xxxMessage:: toBuffer(char **buffer) const
{
    int32 nbytes;

    nbytes = Message::toBuffer(buffer);
    //now transfer any values added by the message type
    // nbytes += MPF::toBuffer(buffer,???);
    return(nbytes);
}

int32 xxxMessage:: fromBuffer(const char **buffer)
{
    int32 nbytes=0;

    nbytes = Message::fromBuffer(buffer);
    //now transfer any values added by the message type
    //nbytes += MPF::fromBuffer(buffer,&???);
    return(nbytes);
}

int32 xxxMessage:: fromBufferSwitch(const char **buffer)
{
    int32 nbytes=0;

    nbytes = Message::fromBufferSwitch(buffer);
    //now transfer any values added by the message type
    //nbytes += MPF::fromBufferSwitch(buffer,&???);
    return(nbytes);
}

void xxxMessage:: print() const
{
    Message::print();
    //print any values added by the message type
    //printf("value %d\n",???);
}

void *xxxMessage:: operator new(size_t size)
{
    if(size!=sizeof(xxxMessage)) {
        printf("xxxMessage new size !=sizeof(xxxMessage)\n");
        epicsThreadSuspendSelf();
    }
    return MPF:: allocate(&pFreeList,size);
}
 
void xxxMessage:: operator delete(void *p, size_t size)
{
    if(size==sizeof(xxxMessage)) {
	MPF::free(pFreeList,p,size);
	return;
    }
    printf("xxxMessage delete size !=sizeof(xxxMessage)\n");
}

